<?php

function dom_to_simple_array($domnode, &$array) 
{
    $array_ptr = &$array;
    $domnode = $domnode->firstChild;
    while (!is_null($domnode)) 
    {
        if (! (trim($domnode->nodeValue) == "") ) 
        {
            switch ($domnode->nodeType) 
            {
                case XML_TEXT_NODE: 
                {
                    $array_ptr['cdata'] = $domnode->nodeValue;
                    break;
                }
                case XML_ELEMENT_NODE:  
                {
                    $array_ptr = &$array[$domnode->nodeName][];
                    if ($domnode->hasAttributes() ) 
                    {
                        $attributes = $domnode->attributes;
                        if (!is_array ($attributes)) 
                        {
                            break;
                        }
                        foreach ($attributes as $index => $domobj) 
                        {
                            $array_ptr[$index] = $array_ptr[$domobj->name] = $domobj->value;
                        }
                    }
                    break;
                }
            }
            if ( $domnode->hasChildNodes() ) 
            {
                dom_to_simple_array($domnode, $array_ptr);
            }
        }
        $domnode = $domnode->nextSibling;
    }
}; 


function print_in_KMGT_octet($val)
{
    if(preg_match("/^\d+$/",$val))
    {
        if(strlen($val) <4)
        {    
            return "$val Octets";
        }
        elseif(strlen($val) >3 and strlen($val) <7)
        {
            $kilo = substr($val,0,-3);
            return "$kilo.Ko";

        }
        elseif(strlen($val) >6 and strlen($val) <10)
        {
            $mega = substr($val,0,-6);
            return "$mega.Mo";

        }
        elseif(strlen($val) >9 and strlen($val) <13)
        {
            $giga = substr($val,0,-9);
            return "$giga.Go";

        }
        elseif(strlen($val) >13)
        {
            $tera = substr($val,0,-12);
            return "$tera.To";
        };
        
    }
    else
    {
        return $val;
    };
};



/*
XML Parser : 
Return array 

$filename : a date format  yyyy_mm_W | yyyy_mm | yyyy
$type : y|m|w|"" (empty)
*/

function parse_xml_file($filename,$type)
{
    Global $path_to_resume_xml, $max_element_in_top ;
        
    $file = $path_to_resume_xml."$filename.xml";
    $this_array = array();


    $dom = new DomDocument ;
    $dom -> load($file);

    $data = array();

    dom_to_simple_array($dom,$data);

    $TopMailSent_temp = $data['statsbyuser'][0]['TopMailSent'][0][user];
    $TopMailSentTotalSize_temp = $data['statsbyuser'][0]['TopMailSentTotalSize'][0][user];
    
    if(!empty($TopMailSent_temp)) { 
		$TopMailSent = array_slice($TopMailSent_temp,0,$max_element_in_top);
		foreach($TopMailSent as $entry) {
		    $key = $entry['name']['0'][cdata];
		    $nb  = $entry['mailSent']['0'][cdata];
		    $vol = $entry['mailSentTotalSize']['0'][cdata];
		    
		    $this_array[TopMailSent]["$key"][nb]  = $nb ;
		    $this_array[TopMailSent]["$key"][vol] = $vol; 
		};
	};
	
 	if(!empty($TopMailSentTotalSize_temp)) { 
		$TopMailSentTotalSize = array_slice($TopMailSentTotalSize_temp,0,$max_element_in_top);   
		foreach($TopMailSentTotalSize as $entry) {
		    $key = $entry['name']['0'][cdata];
		    $nb  = $entry['mailSent']['0'][cdata];
		    $vol = $entry['mailSentTotalSize']['0'][cdata];
		    
		    $this_array[TopMailSentTotalSize]["$key"][nb]  = $nb ;
		    $this_array[TopMailSentTotalSize]["$key"][vol] = $vol; 
		};
	};

    return $this_array;

};


function parse_xmlDomain_file($filename,$type)
{
    Global $path_to_resume_xmlDomain, $max_element_in_top ;
        
    $file = $path_to_resume_xmlDomain."$filename.xml";
    $this_array = array();


    $dom = new DomDocument ;
    $dom -> load($file);

    $data = array();

    dom_to_simple_array($dom,$data);

    $TopMailSent_temp = $data['statsbyuser'][0]['TopMailSent'][0][user];
    $TopMailSentTotalSize_temp = $data['statsbyuser'][0]['TopMailSentTotalSize'][0][user];
    
    if(!empty($TopMailSent_temp)) { 
		$TopMailSent = array_slice($TopMailSent_temp,0,$max_element_in_top);
		foreach($TopMailSent as $entry) {
		    $key = $entry['name']['0'][cdata];
		    $nb  = $entry['mailSent']['0'][cdata];
		    $vol = $entry['mailSentTotalSize']['0'][cdata];
		    
		    $this_array[TopMailSent]["$key"][nb]  = $nb ;
		    $this_array[TopMailSent]["$key"][vol] = $vol; 
		};
	};
	
 	if(!empty($TopMailSentTotalSize_temp)) { 
		$TopMailSentTotalSize = array_slice($TopMailSentTotalSize_temp,0,$max_element_in_top);   
		foreach($TopMailSentTotalSize as $entry) {
		    $key = $entry['name']['0'][cdata];
		    $nb  = $entry['mailSent']['0'][cdata];
		    $vol = $entry['mailSentTotalSize']['0'][cdata];
		    
		    $this_array[TopMailSentTotalSize]["$key"][nb]  = $nb ;
		    $this_array[TopMailSentTotalSize]["$key"][vol] = $vol; 
		};
	};


    return $this_array;

};


function parse_xmlDomainOutgoing_file($filename,$type)
{
    Global $path_to_resume_xmlDomainOutgoing, $max_element_in_top ;

    $file = $path_to_resume_xmlDomainOutgoing."$filename.xml";
    $this_array = array();


    $dom = new DomDocument ;
    $dom -> load($file);

    $data = array();

    dom_to_simple_array($dom,$data);

    $TopMailSent_temp = $data['statsbyuser'][0]['TopMailSent'][0][user];
    $TopMailSentTotalSize_temp = $data['statsbyuser'][0]['TopMailSentTotalSize'][0][user];
    
    if(!empty($TopMailSent_temp)) { 
		$TopMailSent = array_slice($TopMailSent_temp,0,$max_element_in_top);
		foreach($TopMailSent as $entry) {
		    $key = $entry['name']['0'][cdata];
		    $nb  = $entry['mailSent']['0'][cdata];
		    $vol = $entry['mailSentTotalSize']['0'][cdata];
		    
		    $this_array[TopMailSent]["$key"][nb]  = $nb ;
		    $this_array[TopMailSent]["$key"][vol] = $vol; 
		};
	};
	
 	if(!empty($TopMailSentTotalSize_temp)) { 
		$TopMailSentTotalSize = array_slice($TopMailSentTotalSize_temp,0,$max_element_in_top);   
		foreach($TopMailSentTotalSize as $entry) {
		    $key = $entry['name']['0'][cdata];
		    $nb  = $entry['mailSent']['0'][cdata];
		    $vol = $entry['mailSentTotalSize']['0'][cdata];
		    
		    $this_array[TopMailSentTotalSize]["$key"][nb]  = $nb ;
		    $this_array[TopMailSentTotalSize]["$key"][vol] = $vol; 
		};
	};

    return $this_array;

};


/*
$date : format  yyyy-mm-dd
$type : y|m|w|"" (empty)
*/

function display_mail_stat_by_user($date,$type) {
    Global $l_block_more, $l_block_other_day, $l_block_last_week, $l_block_to ;	
    Global $l_block_sent_vol_title,$l_block_sent_nb_title, $l_block_account, $l_block_account_sent_nb, $l_block_account_sent_vol;
    Global $l_block_while;

    $filename = xml_file_format_from_a_date($date,$type) ;
    $part = explode("_", $filename);

    if($res = parse_xml_file($filename,$type)) {
        if(empty($date)) {
            $when = "$l_block_last_day";        
        } else {
            $when = " ".get_litteral_date($date);
        };    


        if($type == "w") {
            $when = "$l_block_last_week ".$part[2];
        };

        if($type == "m") {
            $when = "$l_block_while ".get_month($part[1])." ".$part[0];
        };
        
        if($type == "y") {
            $when = "$l_block_while ".$part[0];
        };




        $block .= "<table width='100%' >\n";
        $block .= "<tr><td width='50%'>\n";

	
		if(!empty($res[TopMailSentTotalSize])) {
		    $block .= "<div class=''>";
		    $block .= "<h1 id='xmlDarkGrey' class=''>$l_block_sent_vol_title $when</h1>";
		    $block .= "<table width='100%' id='caption' >\n";
		    $block .= "<caption >\n";
		    $block .= "<td> &nbsp;&nbsp; $l_block_account</td>\n";
		    $block .= "<td align='center' >$l_block_account_sent_nb</td>\n";
		    $block .="<td align='center' bgcolor='#a2cdda' >$l_block_account_sent_vol</td>\n";
		    $block .= "</caption>\n";
		    $block .= "<tr height='5px'></tr>";
		    
		    foreach ( array_keys($res[TopMailSentTotalSize]) as $key) {
		        $block .= "<tr>\n";
		        $block .= "<td>&nbsp;&nbsp; ".str_replace("\\","",$key)."</td>\n";
		        $block .= "<td align='center'>".$res[TopMailSentTotalSize][$key]['nb']."</td>\n";
		        $block .= "<td align='center' bgcolor='#a2cdda'>".print_in_KMGT_octet($res[TopMailSentTotalSize][$key]['vol'])."</td>\n";
		        $block .= "</tr>\n";
		    };

		    $block .="</table>\n";
		    $block .= "</div>";
        };

        $block .= "</td>\n";
        $block .= "<td width='50%'>\n";    
    
		if(!empty($res[TopMailSent])) {        
		    $block .= "<div class=''>";
		    $block .= "<h1  id='xmlDarkGrey' class=''>$l_block_sent_nb_title $when</h1>";
		    $block .= "<table width='100%' >\n";
		    $block .= "<caption >\n";
		    $block .= "<td>&nbsp;&nbsp; $l_block_account</td>\n";
		    $block .= "<td align='center' bgcolor='#a2cdda' >$l_block_account_sent_nb</td>\n";
		    $block .="<td align='center'>$l_block_account_sent_vol</td>\n";
		    $block .= "</caption>\n";
		    $block .= "<tr height='5px'></tr>";
		    foreach ( array_keys($res[TopMailSent]) as $key) {
		        $block .= "<tr>\n";
		        $block .= "<td>&nbsp;&nbsp; ".str_replace("\\","",$key)."</td>\n";
		        $block .= "<td align='center' bgcolor='#a2cdda'>".$res[TopMailSent][$key]['nb']."</td>\n";
		        $block .= "<td align='center' >".print_in_KMGT_octet($res[TopMailSent][$key]['vol'])."</td>\n";
		        $block .= "</tr>\n";

		    };

		    $block .="</table>\n";
		    $block .= "</div>";
		};
        $block .= "</td></tr>\n";
        $block .="</table>\n";

        return $block;
    };
};


function display_mail_stat_by_domain($date,$type) {
    Global $l_block_more, $l_block_other_day, $l_block_last_week, $l_block_to ;	
    Global $l_block_domain_incoming_vol_title, $l_block_domain_incoming_nb_title,  $l_block_domain, $l_block_domain_incoming_nb, $l_block_domain_incoming_vol;
    Global $l_block_while;

    $filename = xml_file_format_from_a_date($date,$type) ;
    $part = explode("_", $filename);

    if($res = parse_xmlDomain_file($filename,$type)) {
        if(empty($date)) {
            $when = "$l_block_last_day";        
        } else {
            $when = " ".get_litteral_date($date);
        };    


        if($type == "w") {
            $when = "$l_block_last_week ".$part[2];
        };

        if($type == "m") {
            $when = "$l_block_while ".get_month($part[1])." ".$part[0];
        };
        if($type == "y") {
            $when = "$l_block_while ".$part[0];
        };

        $block .= "<table width='100%' >\n";
        $block .= "<tr><td width='50%'>\n";
		if(!empty($res[TopMailSentTotalSize])) {
		    $block .= "<div class=''>";
		    $block .= "<h1  id='xmlDarkGrey' class=''>$l_block_domain_incoming_vol_title $when</h1>";
		    $block .= "<table width='100%' >\n";
		    $block .= "<caption >\n";
		    $block .= "<td>&nbsp;&nbsp; $l_block_domain</td>\n";
		    $block .= "<td align='center' >$l_block_domain_incoming_nb</td>\n";
		    $block .="<td align='center' bgcolor='#a2cdda' >$l_block_domain_incoming_vol</td>\n";
		    $block .= "</caption>\n";
		    $block .= "<tr height='5px'></tr>";
		    
		    foreach ( array_keys($res[TopMailSentTotalSize]) as $key) {
		        $block .= "<tr>\n";
		        $block .= "<td>&nbsp;&nbsp; ".str_replace("\\","",$key)."</td>\n";
		        $block .= "<td align='center'>".$res[TopMailSentTotalSize][$key]['nb']."</td>\n";
		        $block .= "<td align='center'bgcolor='#a2cdda'>".print_in_KMGT_octet($res[TopMailSentTotalSize][$key]['vol'])."</td>\n";
		        $block .= "</tr>\n";
		    };

        	$block .="</table>\n";
           	$block .= "</div>";
        };

        $block .= "</td>\n";
        $block .= "<td width='50%'>\n";        
		if(!empty($res[TopMailSent])) {        
		    $block .= "<div class=''>";
		    $block .= "<h1  id='xmlDarkGrey' class=''>$l_block_domain_incoming_nb_title $when</h1>";
		    $block .= "<table width='100%' >\n";
		    $block .= "<caption >\n";
		    $block .= "<td>&nbsp;&nbsp; $l_block_domain</td>\n";
		    $block .= "<td align='center' bgcolor='#a2cdda' >$l_block_domain_incoming_nb</td>\n";
		    $block .="<td align='center'>$l_block_domain_incoming_vol</td>\n";
		    $block .= "</caption>\n";
		    $block .= "<tr height='5px'></tr>";
		    foreach ( array_keys($res[TopMailSent]) as $key)
		    {
		        $block .= "<tr>\n";
		        $block .= "<td>&nbsp;&nbsp; ".str_replace("\\","",$key)."</td>\n";
		        $block .= "<td align='center' bgcolor='#a2cdda'>".$res[TopMailSent][$key]['nb']."</td>\n";
		        $block .= "<td align='center' >".print_in_KMGT_octet($res[TopMailSent][$key]['vol'])."</td>\n";
		        $block .= "</tr>\n";

		    };

		    $block .="</table>\n";
		    $block .= "</div>";
		};
        $block .= "</td></tr>\n";
        $block .="</table>\n";

        return $block;
    };
};



function display_mail_stat_by_domain_outgoing($date,$type) {
    Global $l_block_more, $l_block_other_day, $l_block_last_week, $l_block_to ;
    Global $l_block_domain_outgoing_vol_title, $l_block_domain_outgoing_nb_title,  $l_block_domain, $l_block_domain_outgoing_nb, $l_block_domain_outgoing_vol;
    Global $l_block_while;

    $filename = xml_file_format_from_a_date($date,$type) ;
    $part = explode("_", $filename);

    if($res = parse_xmlDomainOutgoing_file($filename,$type)) {
        if(empty($date)) {
            $when = "$l_block_last_day";
        } else {
            $when = " ".get_litteral_date($date);
        };


        if($type == "w") {
            $when = "$l_block_last_week ".$part[2];
        };

        if($type == "m") {
            $when = "$l_block_while ".get_month($part[1])." ".$part[0];
        };
        if($type == "y") {
            $when = "$l_block_while ".$part[0];
        };

        $block .= "<table width='100%' >\n";
        $block .= "<tr><td width='50%'>\n";
		if(!empty($res[TopMailSentTotalSize])) {

		    $block .= "<div class=''>";
		    $block .= "<h1  id='xmlDarkGrey' class=''>$l_block_domain_outgoing_vol_title $when</h1>";
		    $block .= "<table width='100%' id='caption'>\n";
		    $block .= "<caption >\n";
		    $block .= "<td>&nbsp;&nbsp; $l_block_domain</td>\n";
		    $block .= "<td align='center' >$l_block_domain_outgoing_nb</td>\n";
		    $block .="<td align='center' bgcolor='#a2cdda' >$l_block_domain_outgoing_vol</td>\n";
		    $block .= "</caption>\n";
		    $block .= "<tr height='5px'></tr>";

		    foreach ( array_keys($res[TopMailSentTotalSize]) as $key) {
		        $block .= "<tr>\n";
		        $block .= "<td>&nbsp;&nbsp; ".str_replace("\\","",$key)."</td>\n";
		        $block .= "<td align='center'>".$res[TopMailSentTotalSize][$key]['nb']."</td>\n";
		        $block .= "<td align='center'bgcolor='#a2cdda'>".print_in_KMGT_octet($res[TopMailSentTotalSize][$key]['vol'])."</td>\n";
		        $block .= "</tr>\n";
		    };

        	$block .="</table>\n";
           	$block .= "</div>";
		};

        $block .= "</td>\n";
        $block .= "<td width='50%'>\n";

		if(!empty($res[TopMailSent])) {
		    $block .= "<div class=''>";
		    $block .= "<h1  id='xmlDarkGrey' class=''>$l_block_domain_outgoing_nb_title $when</h1>";
		    $block .= "<table width='100%' >\n";
		    $block .= "<caption >\n";
		    $block .= "<td>&nbsp;&nbsp; $l_block_domain</td>\n";
		    $block .= "<td align='center' bgcolor='#a2cdda' >$l_block_domain_outgoing_nb</td>\n";
		    $block .="<td align='center'>$l_block_domain_outgoing_vol</td>\n";
		    $block .= "</caption>\n";
		    $block .= "<tr height='5px'></tr>";
		    foreach ( array_keys($res[TopMailSent]) as $key)
		    {
		        $block .= "<tr>\n";
		        $block .= "<td>&nbsp;&nbsp; ".str_replace("\\","",$key)."</td>\n";
		        $block .= "<td align='center' bgcolor='#a2cdda'>".$res[TopMailSent][$key]['nb']."</td>\n";
		        $block .= "<td align='center' >".print_in_KMGT_octet($res[TopMailSent][$key]['vol'])."</td>\n";
		        $block .= "</tr>\n";

		    };

		    $block .="</table>\n";
		    $block .= "</div>";
		};
        $block .= "</td></tr>\n";
        $block .="</table>\n";

        return $block;
    };
};




/*

$date : format  yyyy-mm-dd
$type : y|m|w|"" (empty)
*/

function xml_file_format_from_a_date($date,$type)
{
    $date = preg_replace("/[^0-9]/","",$date);

    $year  = substr($date,0,4);
    $month = substr($date,4,2);
    $day   = substr($date,6,2);

    if($type == "")
    {
        $week = date("W",mktime(0,0,0,$month,$day,$year)) ;
        $week += 0 ;
        $this_format = $year."_".$month."_".$week."_".$day;

    };

    if($type == "w")
    {
        $week = date("W",mktime(0,0,0,$month,$day,$year)) ;
        $week += 0 ;
        $this_format = $year."_".$month."_".$week;

    } ;
    
    if($type == "m")
    {
        $this_format = $year."_".$month;
    };

    if($type == "y")
    {
        $this_format = "$year";
    };

    return $this_format ;
};

function xml_form()
{
    Global $l_block_other_day,$l_block_submit ;

    $form = "
    <div>
    <h1 id='xmlDarkBlue' class=''>
    <form method='POST' action='?' name='xmlfrm'>
        <table class='myCalTable'>
            <tr>
                <td>
                    $l_block_other_day  : 
                </td>
                <td>
                    <input type='text' name=\"this_xml_date\" style='width:150px;'/>
                    <script language='JavaScript'>
                    new tcal ({
                        // form name
                        'formname': 'xmlfrm',
                        // input name
                        'controlname': 'this_xml_date'
                    });
                </script>
                </td>
                <td>
                    <input type='hidden' name='action' value='usermailstat'>
                    <input type='hidden' name='item' value='Top'>
                </td>
                <td>
                    <input type='submit' name='Submit' value='$l_block_submit'>
                </td>
            </tr>
        </table>
    </form>
    </h1>
    </div>\n";

    return $form ;



};


function xmlDomain_form()
{
    Global $l_block_other_day,$l_block_submit ;

    $form = "
    <div>
    <h1 id='xmlDarkBlue' class=''>
    <form method='POST' action='?' name='xmlDomainfrm'>
        <table class='myCalTable'>
            <tr>
                <td>
                    $l_block_other_day  : 
                </td>
                <td>
                    <input type='text' name=\"this_xml_date\" style='width:150px;'/>
                    <script language='JavaScript'>
                    new tcal ({
                        // form name
                        'formname': 'xmlDomainfrm',
                        // input name
                        'controlname': 'this_xml_date'
                    });
                </script>
                </td>
                <td>
                    <input type='hidden' name='action' value='domainmailstat'>
                    <input type='hidden' name='item' value='Top'>
                </td>
                <td>
                    <input type='submit' name='Submit' value='$l_block_submit'>
                </td>
            </tr>
        </table>
    </form>
    </h1>
    </div>\n";

    return $form ;



};

function xmlDomainOutgoing_form()
{
    Global $l_block_other_day,$l_block_submit ;

    $form = "
    <div>
    <h1 id='xmlDarkBlue' class=''>
    <form method='POST' action='?' name='xmlDomainfrm'>
        <table class='myCalTable'>
            <tr>
                <td>
                    $l_block_other_day  :
                </td>
                <td>
                    <input type='text' name=\"this_xml_date\" style='width:150px;'/>
                    <script language='JavaScript'>
                    new tcal ({
                        // form name
                        'formname': 'xmlDomainfrm',
                        // input name
                        'controlname': 'this_xml_date'
                    });
                </script>
                </td>
                <td>
                    <input type='hidden' name='action' value='domainmailstatoutgoing'>
                    <input type='hidden' name='item' value='Top'>
                </td>
                <td>
                    <input type='submit' name='Submit' value='$l_block_submit'>
                </td>
            </tr>
        </table>
    </form>
    </h1>
    </div>\n";

    return $form ;



};


?>
